package xxmath.hundred;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;

import xxmath.hundred.RandomHundred.Addition;
import xxmath.hundred.RandomHundred.Division;
import xxmath.hundred.RandomHundred.Multiplication;
import xxmath.hundred.RandomHundred.Subtraction;

public class HundredBuilder {

    /** [eBeBNX */
    private HundredBuilder() {}

    /**
     * ̑Z̕S܂vZԂB
     * 
     * @param size S}XvZ̃TCY
     * @param xMin ̗̐̍ŏl
     * @param xMax ̗̐̍ől
     * @param yMin ̗̐̍ŏl
     * @param yMax ̗̐̍ől
     * @return S܂vZIuWFNg
     */
    public static Hundred createAddition(int size, int xMin, int xMax,
                                                     int yMin, int yMax) {
        RandomHundred hundred = new Addition();
        hundred.create(size, xMin, xMax, yMin, yMax);
        return hundred;
    }

    /**
     * ̈Z̕S܂vZԂB
     * 
     * @param size S}XvZ̃TCY
     * @param xMin ̗̐̍ŏl
     * @param xMax ̗̐̍ől
     * @param yMin ̗̐̍ŏl
     * @param yMax ̗̐̍ől
     * @return S܂vZIuWFNg
     */
    public static Hundred createSubtraction(int size, int xMin, int xMax,
                                                        int yMin, int yMax) {
        RandomHundred hundred = new Subtraction();
        hundred.create(size, xMin, xMax, yMin, yMax);
        return hundred;
    }

    /**
     * ̊|Z̕S܂vZԂB
     * 
     * @param size S}XvZ̃TCY
     * @param xMin ̗̐̍ŏl
     * @param xMax ̗̐̍ől
     * @param yMin ̗̐̍ŏl
     * @param yMax ̗̐̍ől
     * @return S܂vZIuWFNg
     */
    public static Hundred createMultiplication(int size, int xMin, int xMax,
                                                        int yMin, int yMax) {
        RandomHundred hundred = new Multiplication();
        hundred.create(size, xMin, xMax, yMin, yMax);
        return hundred;
    }

    /**
     * ̊Z̕S܂vZԂB
     * 
     * @param size S}XvZ̃TCY
     * @param xMin ̗̐̍ŏl
     * @param xMax ̗̐̍ől
     * @param yMin ̗̐̍ŏl
     * @param yMax ̗̐̍ől
     * @return S܂vZIuWFNg
     */
    public static Hundred createDivision(int size, int xMin, int xMax,
                                                     int yMin, int yMax) {
        RandomHundred hundred = new Division();
        hundred.create(size, xMin, xMax, yMin, yMax);
        return hundred;
    }

    /**
     * t@CS܂vZ쐬ԂB
     * 
     * @param path t@CpX
     * @return S܂vZIuWFNg
     */
    public static Hundred read(File file)
                                throws FileNotFoundException, IOException {
        BufferedReader br = null;
        Hundred hundred = null;
        try {
            br = new BufferedReader(new FileReader(file));

            // 1sڂ̓ǂݍ
            String line = br.readLine();

            String[] text = line.split(",");
            int size = text.length - 1;
            if (size < 2) {
                throw new IOException(file + " (ǂݍ݃G[łB)");
            }

            String symbol = text[0];

            int[] x = new int[size];
            int[] y = new int[size];
            int[][] answers = new int[size][size];
            for (int i = 1; i < text.length; i++) {
                x[i - 1] = Integer.parseInt(text[i]);
            }

            // 2sڈȍ~̓ǂݍ
            for (int i = 0; (line = br.readLine()) != null; i++) {
                text = line.split(",");
                y[i] = Integer.parseInt(text[0]);

                for (int j = 1; j < text.length; j++) {
                    answers[i][j - 1] = Integer.parseInt(text[j]);
                }
            }

            hundred = new Hundred();
            hundred.setSymbol(symbol);
            hundred.setX(x);
            hundred.setY(y);
            hundred.setAnswers(answers);

        } finally {
            if (br != null) {
                br.close();
            }
        }
        return hundred;
    }

    /**
     * t@CɕS܂vZۑB
     * 
     * @param file ۑΏۃt@C
     * @throws FileNotFoundException
     * @throws IOException
     */
    public static void write(File file, Hundred hundred)
                    throws FileNotFoundException, IOException {
        BufferedWriter bw = null;
        try {
            bw = new BufferedWriter(new FileWriter(file));
            bw.write(hundred.toCSV());
        } finally {
            if (bw != null) {
                bw.close();
            }
        }
    }

}
