package xxmath.hundred;

import java.awt.BorderLayout;
import java.awt.Font;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.GridLayout;
import java.awt.Insets;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.FocusAdapter;
import java.awt.event.FocusEvent;
import java.awt.event.FocusListener;
import java.awt.event.KeyListener;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;

import javax.swing.ButtonGroup;
import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JRadioButton;
import javax.swing.JSlider;
import javax.swing.JTextField;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;
import javax.swing.event.DocumentEvent;
import javax.swing.event.DocumentListener;

import xxmath.util.DigitKeyListener;

/**
 * _CAOŕS܂vZ̐ݒNXB
 * 
 * @author Ryo IKEDA
 */
public class HundredDialog extends JDialog {

    private static Hundred hundred;

    /**
     * S܂vZ̐ݒ_CAO\B
     * 
     * @param owner ẽEBhE
     * @param title EBhẼ^Cg
     * @return ͂ݒKpS܂vZAG[nullԂB
     */
    public static Hundred showDialog(JFrame owner, String title) {
        hundred = null;
        new HundredDialog(owner, title).setVisible(true);
        return hundred;
    }

    private JPanel jContentPane;
    private JPanel pnCenter;
    private JPanel pnSouth;
    private JButton btOK;
    private JButton btCansel;
    private JPanel pnX;
    private JTextField tfXMin;
    private JTextField tfXMax;
    private JPanel pnY;
    private JTextField tfYMin;
    private JTextField tfYMax;
    private JPanel pnSize;
    private JSlider jsSize;
    private JLabel lbSize;
    private JPanel pnMode;
    private ButtonGroup bgModes;
    private JRadioButton rbAddition;
    private JRadioButton rbSubtraction;
    private JRadioButton rbMultiplication;
    private JRadioButton rbDivision;
    private Font rbFont;

    private KeyListener keyListener = new DigitKeyListener(2, true);
    private DocumentListener documentListener = new TfDocumentListener();
    private FocusListener focusListener = new TfFocusListener();

    private HundredDialog(JFrame owner, String title) {
        super(owner, true);
        setTitle(title);
        setDefaultCloseOperation(DO_NOTHING_ON_CLOSE);
        initialize();
    }

    private void initialize() {
        setContentPane(getJContentPane());
        setLocationToCenter();
        addWindowListener(new WindowAdapter() {
            @Override
            public void windowClosing(WindowEvent e) {
                dispose();
            }
        });
    }

    private void setLocationToCenter() {
        pack();
        int width = getWidth();
        int height = getHeight();
        int x = getOwner().getX() + (getOwner().getWidth() - width) / 2;
        int y = getOwner().getY() + (getOwner().getHeight() - height) / 2;
        setLocation(x, y);
    }

    private JPanel getJContentPane() {
        if (jContentPane == null) {
            jContentPane = new JPanel(new BorderLayout());
            jContentPane.add(getPnCenter(), BorderLayout.CENTER);
            jContentPane.add(getPnSouth(), BorderLayout.SOUTH);
        }
        return jContentPane;
    }

    private JPanel getPnCenter() {
        if (pnCenter == null) {
            GridBagConstraints gridBagConstraints11 = new GridBagConstraints();
            gridBagConstraints11.gridx = 0;
            gridBagConstraints11.gridy = 0;
            GridBagConstraints gridBagConstraints2 = new GridBagConstraints();
            gridBagConstraints2.insets = new Insets(3, 43, 11, 44);
            gridBagConstraints2.gridy = 3;
            gridBagConstraints2.gridx = 0;
            GridBagConstraints gridBagConstraints1 = new GridBagConstraints();
            gridBagConstraints1.insets = new Insets(3, 43, 2, 44);
            gridBagConstraints1.gridy = 2;
            gridBagConstraints1.gridx = 0;
            GridBagConstraints gridBagConstraints = new GridBagConstraints();
            gridBagConstraints.insets = new Insets(5, 21, 2, 21);
            gridBagConstraints.gridy = 1;
            gridBagConstraints.gridx = 0;
            pnCenter = new JPanel();
            pnCenter.setLayout(new GridBagLayout());
            pnCenter.add(getPnSize(), gridBagConstraints);
            pnCenter.add(getPnX(), gridBagConstraints1);
            pnCenter.add(getPnY(), gridBagConstraints2);
            pnCenter.add(getPnMode(), gridBagConstraints11);
        }
        return pnCenter;
    }

    private JPanel getPnSouth() {
        if (pnSouth == null) {
            pnSouth = new JPanel();
            pnSouth.add(getBtOK());
            pnSouth.add(getBtCansel());
        }
        return pnSouth;
    }

    private JButton getBtOK() {
        if (btOK == null) {
            btOK = new JButton("OK");
            getRootPane().setDefaultButton(btOK);
            btOK.addActionListener(new ActionListener() {
                public void actionPerformed(ActionEvent e) {
                    try {
                        hundred = createHundred();
                    } catch (Exception e1) {
                        hundred = null;
                    } finally {
                        dispose();
                    }
                }
                private Hundred createHundred() {
                    int size = jsSize.getValue();
                    int a = Integer.parseInt(tfXMin.getText());
                    int b = Integer.parseInt(tfXMax.getText());
                    int c = Integer.parseInt(tfYMin.getText());
                    int d = Integer.parseInt(tfYMax.getText());
                    int xMin = Math.min(a, b);
                    int xMax = Math.max(a, b);
                    int yMin = Math.min(c, d);
                    int yMax = Math.max(c, d);
                    Hundred temp = null;
                    if (rbAddition.isSelected()) {
                        temp = HundredBuilder.createAddition(size, xMin, xMax, yMin, yMax);
                    } else if (rbSubtraction.isSelected()) {
                        temp = HundredBuilder.createSubtraction(size, xMin, xMax, yMin, yMax);
                    } else if (rbMultiplication.isSelected()) {
                        temp = HundredBuilder.createMultiplication(size, xMin, xMax, yMin, yMax);
                    } else if (rbDivision.isSelected()) {
                        temp = HundredBuilder.createDivision(size, xMin, xMax, yMin, yMax);
                    }
                    return temp;
                }
            });
        }
        return btOK;
    }

    private JButton getBtCansel() {
        if (btCansel == null) {
            btCansel = new JButton("LZ");
            btCansel.addActionListener(new ActionListener() {
                public void actionPerformed(ActionEvent e) {
                    dispose();
                }
            });
        }
        return btCansel;
    }

    private JPanel getPnX() {
        if (pnX == null) {
            pnX = new JPanel();
            pnX.add(new JLabel("̐F"));
            pnX.add(getTfXMin());
            pnX.add(new JLabel("`"));
            pnX.add(getTfXMax());
        }
        return pnX;
    }

    private JTextField getTfXMin() {
        if (tfXMin == null) {
            tfXMin = new JTextField("0", 3);
            tfXMin.setHorizontalAlignment(JTextField.RIGHT);
            tfXMin.addKeyListener(keyListener);
            tfXMin.addFocusListener(focusListener);
            tfXMin.getDocument().addDocumentListener(documentListener);
        }
        return tfXMin;
    }

    private JTextField getTfXMax() {
        if (tfXMax == null) {
            tfXMax = new JTextField("9", 3);
            tfXMax.setHorizontalAlignment(JTextField.RIGHT);
            tfXMax.addKeyListener(keyListener);
            tfXMax.addFocusListener(focusListener);
            tfXMax.getDocument().addDocumentListener(documentListener);
        }
        return tfXMax;
    }

    private JPanel getPnY() {
        if (pnY == null) {
            pnY = new JPanel();
            pnY.add(new JLabel("̐F"));
            pnY.add(getTfYMin());
            pnY.add(new JLabel("`"));
            pnY.add(getTfYMax());
        }
        return pnY;
    }

    private JTextField getTfYMin() {
        if (tfYMin == null) {
            tfYMin = new JTextField("0", 3);
            tfYMin.setHorizontalAlignment(JTextField.RIGHT);
            tfYMin.addKeyListener(keyListener);
            tfYMin.addFocusListener(focusListener);
            tfYMin.getDocument().addDocumentListener(documentListener);
        }
        return tfYMin;
    }

    private JTextField getTfYMax() {
        if (tfYMax == null) {
            tfYMax = new JTextField("9", 3);
            tfYMax.setHorizontalAlignment(JTextField.RIGHT);
            tfYMax.addKeyListener(keyListener);
            tfYMax.addFocusListener(focusListener);
            tfYMax.getDocument().addDocumentListener(documentListener);
        }
        return tfYMax;
    }

    private JPanel getPnSize() {
        if (pnSize == null) {
            lbSize = new JLabel("", JLabel.CENTER);
            lbSize.setFont(new Font("Dialog", Font.BOLD, 24));
            lbSize.setText("10 x 10");
            pnSize = new JPanel();
            pnSize.setLayout(new GridLayout(2, 1));
            pnSize.add(lbSize);
            pnSize.add(getJsSize());
        }
        return pnSize;
    }

    private JSlider getJsSize() {
        if (jsSize == null) {
            jsSize = new JSlider(2, 15, 10);
            jsSize.addChangeListener(new ChangeListener() {
                public void stateChanged(ChangeEvent e) {
                    String text = String.valueOf(jsSize.getValue());
                    lbSize.setText(text + " x " + text);
                }
            });
        }
        return jsSize;
    }

    private JPanel getPnMode() {
        if (pnMode == null) {
            pnMode = new JPanel();
            pnMode.add(getRbAddition());
            pnMode.add(getRbSubtraction());
            pnMode.add(getRbMultiplication());
            pnMode.add(getRbDivision());
            bgModes = new ButtonGroup();
            bgModes.add(getRbAddition());
            bgModes.add(getRbSubtraction());
            bgModes.add(getRbMultiplication());
            bgModes.add(getRbDivision());
            getRbAddition().setSelected(true);
        }
        return pnMode;
    }

    private JRadioButton getRbAddition() {
        if (rbAddition == null) {
            rbAddition = new JRadioButton("{");
            rbAddition.setFont(getRbFont());
        }
        return rbAddition;
    }

    private JRadioButton getRbSubtraction() {
        if (rbSubtraction == null) {
            rbSubtraction = new JRadioButton("|");
            rbSubtraction.setFont(getRbFont());
        }
        return rbSubtraction;
    }

    private JRadioButton getRbMultiplication() {
        if (rbMultiplication == null) {
            rbMultiplication = new JRadioButton("~");
            rbMultiplication.setFont(getRbFont());
        }
        return rbMultiplication;
    }

    private JRadioButton getRbDivision() {
        if (rbDivision == null) {
            rbDivision = new JRadioButton("");
            rbDivision.setFont(getRbFont());
        }
        return rbDivision;
    }

    private Font getRbFont() {
        if (rbFont == null) {
            rbFont = new Font("Dialog", Font.BOLD, 14);
        }
        return rbFont;
    }

    /**
     * eLXgtB[h̓eɂJButtongpsɂB
     */
    private class TfDocumentListener implements DocumentListener {
        public void changedUpdate(DocumentEvent e) {}
        public void insertUpdate(DocumentEvent e) {
            setJButton();
        }
        public void removeUpdate(DocumentEvent e) {
            setJButton();
        }
        private void setJButton() {
            String xmax = getTfXMax().getText();
            String xmin = getTfXMin().getText();
            String ymax = getTfYMax().getText();
            String ymin = getTfYMin().getText();
            String regax = "-?\\d{1,2}";
            if (xmax.matches(regax)
                    && xmin.matches(regax)
                    && ymax.matches(regax)
                    && ymin.matches(regax)) {
                getBtOK().setEnabled(true);
            } else {
                getBtOK().setEnabled(false);
            }
        }
    }

    /**
     * tH[JX𓾂ƂeLXgIB
     */
    private class TfFocusListener extends FocusAdapter {
        @Override
        public void focusGained(FocusEvent e) {
            JTextField tf = (JTextField)e.getSource();
            tf.selectAll();
        }
    }

}
