package xxmath.hundred;

import java.util.Random;

/**
 * ŕS܂vZ쐬钊ۃNXB
 * 
 * @author Ryo IKEDA
 */
abstract class RandomHundred extends Hundred {

    /** IuWFNg */
    private static final Random random = new Random();

    /** S܂vZ̃TCY */
    private int size;

    /**
     * TCYƗ̕w肵ĕS܂vZ𐶐B
     * 
     * @param size S}XvZ̃TCY
     * @param xMin ̗̐̍ŏl
     * @param xMax ̗̐̍ől
     * @param yMin ̗̐̍ŏl
     * @param yMax ̗̐̍ől
     */
    void create(int size, int xMin, int xMax, int yMin, int yMax) {
        this.size = size;
        super.setX(randomArray(xMin, xMax));
        super.setY(randomArray(yMin, yMax));
        super.setAnswers(createAnswers());
    }

    /**
     * ̐ƍ̐瓚vZĔzɊi[ԂB
     * 
     * @return ̔z
     */
    private int[][] createAnswers() {
        int[][] answers = new int[size][size];

        for (int i = 0; i < answers.length; i++) {
            for (int j = 0; j < answers[0].length; j++) {
                answers[i][j] = calculate(getXAt(j), getYAt(i));
            }
        }

        return answers;
    }

    /**
     * S܂vZ̓vZB
     * 
     * @param x ̐
     * @param y ̐
     * @return vZ
     */
    protected abstract int calculate(int x, int y);

    /**
     * ̔zԂB
     * 
     * @param min z̊evf̍ŏl
     * @param max z̊evf̍ől
     */
    private int[] randomArray(int min, int max) {
        int[] temp = new int[size];
        for (int i = 0; i < temp.length; i++) {
            boolean found;
            do {
                found = false;
                temp[i] = random(min, max);

                /* ̕TCY菬ꍇA
                   ̏d */
                if (max - min + 1 < size) {
                    break;
                }

                /* ̏d𔻒f */
                for (int j = i - 1; j >= 0; j--) {
                    if (temp[i] == temp[j]) {
                        found = true;
                        break;
                    }
                }
            } while (found);
        }
        return temp;
    }

    /**
     *  minȏmaxȉ̗ԂB
     * 
     * @param min ̍ŏl
     * @param max ̍ől
     */
    private int random(int min, int max) {
        int length = Math.abs(max - min + 1);
        int position = 0 - min;
        return (random.nextInt(length) - position);
    }

    /**
     * ZNXB
     */
    static class Addition extends RandomHundred {

        Addition() {
            setSymbol("{");
        }

        /**
         * ZB
         */
        @Override
        protected int calculate(int x, int y) {
            return x + y;
        }

    }

    /**
     * ZNXB
     */
    static class Subtraction extends RandomHundred {

        Subtraction() {
            setSymbol("|");
        }

        /**
         * ̐獶̐B
         */
        @Override
        protected int calculate(int x, int y) {
            return x - y;
        }

    }

    /**
     * |ZNXB
     */
    static class Multiplication extends RandomHundred {

        Multiplication() {
            setSymbol("~");
        }

        /**
         * |ZB
         */
        @Override
        protected int calculate(int x, int y) {
            return x * y;
        }

    }

    /**
     * ZNXB
     */
    static class Division extends RandomHundred {

        Division() {
            setSymbol("");
        }

        /**
         * ̐獶̐B
         * ̐(鐔)0̏ꍇA̐(鐔)ԂB
         */
        @Override
        protected int calculate(int x, int y) {
            if (y == 0) {
                return x;
            }
            int n = x % y;
            return n;
        }

    }

}
